/*
 * Copyright (c) 2012, The University of Texas at Austin.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the copyright holder nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Authors: Min Kyu Jeong
 */

#include "addrdecoder.h"
#include "dsim_trace.h"
#include "system.h"
#include "common.h"
#include <vector>

#define NUM_ROW_TO_PRINT 5
#define NUM_COL_TO_PRINT 4
#define ADDR_TO_GEN 5000000

using std::cout;
using std::endl;

int main(int argc, char* argv[], char* argp[]) {
  Args args;
  args.parse_input_args(argc, argv);
  args.print(cout);

  AddrDecoder decoder(args.get_num_channel(), //UINT32 num_channel,
                      args.get_num_rank(), //UINT32 num_rank,
                      args.get_num_chip(), //UINT32 num_chip,
                      args.get_num_bank(), //UINT32 num_bank,
                      args.get_num_row(), //UINT32 num_row,
                      args.get_num_column(), //UINT32 num_column,
                      args.get_chip_width(), //UINT32 chip_width,
                      args.get_burst_length(), //UINT32 burst_length,
                      args.get_channel_interleaving_granularity(), // UINT32 channel_interleaving_granularity,
                      true, // bool rank_interleaving
                      args.get_subrank_width(), //UINT32 subrank_width,
                      args.get_subrank_interleaving_granularity(), //UINT32 subrank_interleaving_granularity);
                      true,
                      true,
                      true);
  decoder.PrintMask(cout);

//  TraceSimArgs args;
//  parse_input_args(args, argc, argv);
//  DRAMModule module_config = args.get_module_config();
//
//  AddrDecoder* decoder;
//  UINT32 num_channel = args.get_num_channel();
//  if (args.get_addr_mask().empty()) {
//    decoder = new AddrDecoder(num_channel,
//                              args.get_module_config(),
//                              args.get_subrank_xor_hash(),
//                              args.get_channel_xor_hash(),
//                              args.get_subrank_map(),
//                              args.get_subrank_offset(),
//                              args.get_channel_offset(),
//                              args.get_rank_interleave());
//  }
//  else {
//    decoder = new AddrDecoder(num_channel,
//                              args.get_module_config(),
//                              args.get_addr_mask(),
//                              string(""));
//  }
//  decoder->printMask(std::cout);
//
//  int num_subrank = module_config.num_subrank;
//  int num_row = module_config.num_row;
//  assert(num_row >= NUM_ROW_TO_PRINT);
//
//  // rows[channel][subrank][row]
//  vector<ADDRESS>*** rows;
//  rows = new vector<ADDRESS>**[args.get_num_channel()];
//  for (UINT32 i = 0; i < args.get_num_channel(); i++) {
//    rows[i] = new vector<ADDRESS>*[num_subrank];
//    for (int j = 0; j < num_subrank; j++) {
//      rows[i][j] = new vector<ADDRESS>[num_row];
//    }
//  }
//
//  // decode addrs 
//  DRAMAddr daddr;
//  ADDRESS paddr = 0;
//  for (; paddr < ADDR_TO_GEN; paddr++) {
//    decoder->decode(paddr, 1, &daddr);
//    int channel = decoder->get_channel(paddr);
//    int subrank = decoder->get_subrank(paddr);
//    int row = decoder->get_row(paddr);
//    int column = decoder->get_column(paddr);
//    int bank = decoder->get_bank(paddr);
//
//    if (bank == 0 && column < NUM_COL_TO_PRINT)
//      rows[channel][subrank][row].push_back(paddr);
//  }
//
//  // print them
//  for (UINT32 i = 0; i < args.get_num_channel(); i++) {
//    for (int k = 0; k < NUM_ROW_TO_PRINT; k++) {
//      for (int j = 0; j < num_subrank; j++) {
//        for (int l = 0; l < NUM_COL_TO_PRINT && l < rows[i][j][k].size(); l++) {
////          cout << std::setw(4) << std::setfill('0') << std::hex << rows[i][j][k][l];
//          cout << std::hex << std::setw(3) << rows[i][j][k][l];
//        }
//
//        cout << "\t";
//      }
//      cout << endl;
//    }
//  }
}
