#include "events.hh"

EventTrace::EventTrace()
{
    globalTrace = NULL;
    curTick = 0;
}

void
EventTrace::setTrace(ET *event_trc) 
{
    globalTrace = event_trc;
}

void
EventTrace::init()
{
    //TEMPLATE: inst_pool[i].etTransIDs[inst_pool[i].et]   = globalTrace->createTransType ("", "");
    etTransIDs[etRdRequest] = globalTrace->createTransType("Read", "New Read Request");
    etTransIDs[etWrRequest] = globalTrace->createTransType("Write", "New Write Request");
    etTransIDs[etGpuRdRequest] = globalTrace->createTransType("GpuRead", "New Gpu Read Request");
    etTransIDs[etGpuWrRequest] = globalTrace->createTransType("GpuWrite", "New Gpu Write Request");

    //TEMPLATE: etEventIDs[et] = globalTrace->createEventType( "", "" , '' );
    etEventIDs[etNewRequest] = globalTrace->createEventType("NewRequest", "Created a New Request", 'N');
    etEventIDs[etCompleteReq] = globalTrace->createEventType("RequestComplete", "Completed the Request", 'D');

    //TEMPLATE: etAttrIDs[et] = globalTrace->createAttrType( "" , "", ET::Attr:: );
    //ET::Attr::Dec, 
    //ET::Attr::Hex, 
    //ET::Attr::Trans
    //ET::Attr::Str
    etAttrIDs[etReqId] = globalTrace->createAttrType("ReqId", "Request ID", ET::Attr::Dec);
    etAttrIDs[etAddr] = globalTrace->createAttrType("Addr", "Address", ET::Attr::Hex);
    etAttrIDs[etReqType] = globalTrace->createAttrType("RequestType", "Request Type", ET::Attr::Str);
}
