#ifndef _EVENTS_HH_
#define _EVENTS_HH_

#include "util/et.hh"
#include "base/types.hh"

class EventTrace
{
  public:
    EventTrace();
    void init();
    void setTrace(ET *event_trc);

    enum etTransTypes {
        etRdRequest,
        etWrRequest,
        etGpuRdRequest,
        etGpuWrRequest,
        NumETTransTypes
    };

    enum etEventTypes {
        etNewRequest,
        etCompleteReq,
        NumETEventTypes
    };

    enum etAttrTypes {
        etReqId,
        etAddr,
        etReqType,
        NumETAttrTypes
    };

    ET* globalTrace;
    ET::transID_t etTransIDs[NumETTransTypes];
    ET::eventID_t etEventIDs[NumETEventTypes];
    ET::attrID_t  etAttrIDs[NumETAttrTypes];

  private:
    Tick curTick;;
};

#endif
